// Written by TeTeT
// display a dialog and rotate it toward the beacon
// based on BIS sample

beacons = [beacon, beacon1, beacon2];

activeBeacon = beacon;

[] spawn {
	waitUntil {alive player};
	sleep 1;
	angle = (player getRelDir activeBeacon);
	uiNamespace setVariable ["angle", angle];
	with uiNamespace do {
		activeBeaconFreq = "1000";

		if (!isNil "ctrl") then {
			ctrlDelete ctrl;
		};
		while {isNull (findDisplay 46)} do {
			sleep 0.1;
 			systemChat "Finding display";
		};
		systemchat "Found display 46";
		ctrl = (findDisplay 46) ctrlCreate ["RscPictureKeepAspect", -1];;
		private ["_x", "_y"];
		_x =  0.3 * safeZoneW + safeZoneX;
		_y = -0.1 * safeZoneH + safeZoneY;
		ctrl ctrlSetPosition [_x, _y, 0.5, 0.5];
		ctrl ctrlSetText "data\Arrow.paa";
	   // ctrl ctrlSetText "\a3\ui_f\data\map\GroupIcons\badge_rotate_0_gs.paa";
		ctrl ctrlSetTextColor [1,1,1,1];
		ctrl ctrlSetAngle [angle, 0.5, 0.5];
		ctrl ctrlCommit 0;

		onEachFrame	{
			if (vehicle player != player and vehicle player isKindOf "Air") then {
				angle = (player getRelDir activeBeacon);
				hint format ["Setting angle to %1", angle];
				uiNamespace setVariable ["angle", angle];
				with uiNamespace do {
					ctrl ctrlSetAngle [angle, 0.5, 0.5];
				};
			} else {
				hint "";
				(uiNamespace getVariable 'ctrl') ctrlSetTextColor [1,1,1,0];
				beaconActive = false;
			};
		};

	};
};

beaconActive = true;

player addAction [
	"Show bearing indicator",
	"beaconActive = true; (uiNamespace getVariable 'ctrl') ctrlSetTextColor [1,1,1,1]",
	"",
	0,
	false,
	true,
	"",
	"!beaconActive and vehicle player != player"
];

player addAction [
	"Hide bearing indicator",
	"beaconActive = false; (uiNamespace getVariable 'ctrl') ctrlSetTextColor [1,1,1,0]",
	"",
	0,
	false,
	true,
	"",
	"beaconActive and vehicle player != player"
];

player addAction [
	"Enter beacon frequency",
	"createDialog 'FrequencyDialog';",
	"",
	0,
	false,
	true,
	"",
	"vehicle player != player and vehicle player isKindOf 'Air'"
];


changeFrequency = {
	private ["_freq", "_beacon"];

	_freq = parseNumber ctrlText 1000;
	_beacon = ObjNull;

	{
		private ["_beaconFreq"];
		_beaconFreq = _x getVariable ["frequency", 0];
		if (_freq == _beaconFreq) then {
			_beacon = _x;
		};
	} forEach beacons;

	if (isNull _beacon) then {
		(vehicle player) vehicleChat "No beacon on that frequency";
	} else {
		activeBeacon = _beacon;
	};
	_beacon;
};
